*---------------------------------------------------------------------------
*-- SD1.PRG for dBase IV
*-- Program calculates sample depth from trees or individual samples that 
*-- can be used in a STEP PLOT graph.  Input via variables IN (inside date)
*-- & OU (outside date).  Uses temporary file TMPSD.STR and SD-OUT.STR for
*-- output structure.
*--
*-- T. Caprio .....: 22-Oct-90
*-- Last Updated ..:  7-Dec-90
*---------------------------------------------------------------------------
SET ECHO OFF
SET TALK OFF
SET STAT OFF
SET SCOR OFF
CLEA ALL
CLEA

DO WHIL .T.
	DO WHIL .T.
		IFILE=SPAC(8)
		OFILE=SPAC(8)
		@ 5,5 SAY 'Enter Input File Name  >>>>' GET IFILE
		@ 7,5 SAY 'Enter Output File Name >>>>' GET OFILE
		@ 9,5 SAY 'Type a "%" to EXIT'
		READ
		IFILE=TRIM(IFILE)
		OFILE=TRIM(OFILE)
		IF '%' $ IFILE .OR. '%' $ OFILE
			SET SCOR ON
			SET TALK ON
			SET ECHO ON
			SET STAT ON
			RETU
		ENDI
		MIFILE=IFILE+'.DBF'
		IF FILE('&MIFILE')
			EXIT
		ELSE
			@ 23,5 SAY 'File Not Found - Retry'
		ENDI
	ENDD
		*Set up routine to check for presence of correct field names.
	
	USE TMPSD.STR
	COPY STRU TO TMPSD
	USE SD-OUT.STR
	COPY STRU TO &OFILE
	
	SELE B
	USE &OFILE
	DELE ALL
	PACK
	SELE C
	USE TMPSD
	SELE A
	USE &IFILE
	
	CLEA
	DO WHIL .T.
		ZGR=SPAC(2)
		@ 5,5 SAY 'Select Output Filter: Choose selection below. >>>>' 
		@ 5,57 GET ZGR PICTURE "##"
		@ 7,5 SAY 'Enter group # or 0 for all groups.'
		@ 9,5 SAY 'Type a "-1" to enter more than 1 group number.'
		@ 11,5 SAY 'Type a "-9" to EXIT.'
		READ
		ZGR=TRIM(ZGR)
		IF LEN(ZGR)=0
			@ 23,10 SAY 'Incorrect Selection - no value - Retry'
			LOOP
		ENDI
		CLEA
		ZGR=VAL(ZGR)
		IF ZGR=-9
			CLOS DATA
			MXOFILE=OFILE+'.DBF'
			ERAS &MXOFILE
			ERAS TMPSD.DBF
			SET SCOR ON
			SET TALK ON
			SET ECHO ON
			SET STAT ON
			CLEA
			RETU
		ENDI
		IF ZGR=0
			EXIT
		ENDI
		IF ZGR=-1
			GRKNT=1
			DO WHIL .T.
				MZGR=SPAC(2)
				IF GRKNT<4
					AGRKNT=LTRIM(STR(GRKNT))+'rd'
					IF GRKNT<3
						AGRKNT=LTRIM(STR(GRKNT))+'nd'
						IF GRKNT<2
							AGRKNT=LTRIM(STR(GRKNT))+'st'
						ENDI
					ENDI
				ELSE
					AGRKNT=LTRIM(STR(GRKNT))+'th'
				ENDI
				@ 5,5 SAY 'Select Output Filter: Enter' 
				@ 5,33 GET AGRKNT
				CLEA GETS
				@ 5,37 SAY 'group #. >>>>' 
				@ 5,50 GET MZGR PICTURE "##"
				@ 7,5 SAY 'Type a "-1" to complete selections.'
				@ 9,5 SAY 'Type a "-9" to EXIT.'
				READ
				IF LEN(TRIM(MZGR))=0
					@ 23,10 SAY 'Incorrect Selection - no value - Retry'
					LOOP
				ENDI
				VZGR=VAL(MZGR)
				IF VZGR=-9
					CLOS DATA
					MXOFILE=OFILE+'.DBF'
					ERAS &MXOFILE
					ERAS TMPSD.DBF
					SET SCOR ON
					SET TALK ON
					SET ECHO ON
					SET STAT ON
					CLEA
					RETU
				ENDI
				IF VZGR=-1
					CLEA
					EXIT
				ELSE
					SELE A
					GO TOP
					LOCA FOR GR=VZGR
					IF .NOT. EOF()
						IF GRKNT=1
							XGR='GR='+TRIM(MZGR)
						ELSE
							XGR=XGR+'.OR.GR='+TRIM(MZGR)
						ENDI
						GRKNT=GRKNT+1
						LOOP
					ENDI
					@ 23,10 SAY 'Group Selection Incorrect - not found - Retry'
				ENDI
			ENDD
			EXIT
		ELSE
			SELE A
			GO TOP
			LOCA FOR GR=ZGR
			IF .NOT. EOF()
				XGR='GR='+TRIM(STR(ZGR))
				EXIT
			ENDI
			@ 23,10 SAY 'Group Selection Incorrect - not found - Retry'
		ENDI
	ENDD
	CLEA
	
	@ 5,25 SAY '** Working - Please Wait **'
	GO TOP
	IF ZGR=0
		SET FILT TO
	ELSE
		SET FILT TO &XGR
	ENDI
	DO WHIL .NOT. EOF()
		SELE C
		APPE BLAN
		REPL GR WITH A->GR, DATE WITH A->IN, TKNT WITH 1
		APPE BLAN
		REPL GR WITH A->GR, DATE WITH A->OU, TKNT WITH -1
		SELE A
		SKIP 1
	ENDD
	SET FILT TO
	
	SELE C
	SORT ON DATE TO TMP
	DELE ALL
	PACK
	APPE FROM TMP
	ERAS TMP.DBF
	
	IF ZGR=0
		SET FILT TO
	ELSE
		SET FILT TO &XGR
	ENDI
	GO TOP
	MSDPTH=0
	@ 7,27 SAY 'Adding Date  :'
	@ 8,27 SAY 'Sample Depth :'
	DO WHIL .NOT. EOF()
		MDATE=DATE
		@ 7,42 GET DATE
		YMSDPTH=STR(MSDPTH)
		YMSDPTH=SUBSTR(YMSDPTH,6,5)
		@ 8,42 GET YMSDPTH
		CLEA GETS
		SUMKNT=TKNT
		MSDPTH1=MSDPTH
		CHK=1
		DO WHIL .T.
			SKIP 1
			CHKDATE=DATE
			IF CHKDATE=MDATE
				CHK=2
				SUMKNT=SUMKNT+TKNT
			ELSE
				IF CHK=2
					MSDPTH=MSDPTH+SUMKNT
				ENDI
				MSDPTH2=MSDPTH
				EXIT
			ENDI
		ENDD
		SKIP -1
		IF SUMKNT<>0
			SELE B
			APPE BLAN
			REPL XGR WITH ZGR, XDATE WITH MDATE, XSDPTH WITH MSDPTH1
			SELE C
			IF CHK=1
				IF TKNT=1
					MSDPTH=MSDPTH+1
				ELSE
					MSDPTH=MSDPTH-1
				ENDI
				MSDPTH2=MSDPTH
			ENDI
			SELE B
			APPE BLAN
			REPL XGR WITH ZGR, XDATE WITH MDATE, XSDPTH WITH MSDPTH2
		ENDI
		SELE C
		SKIP 1
	ENDD
	
	CLOS DATA
	USE &OFILE
	MOFILE=OFILE+'.DAT.'
	COPY TO &MOFILE FIEL XDATE, XSDPTH DELI
	
	CLOS DATA
	MXOFILE=OFILE+'.DBF'
	ERAS &MXOFILE
	ERAS TMPSD.DBF
	
	CLEA
	DO WHIL .T.
		YN=SPAC(1)
		@ 10,5 SAY 'Would you like to calculate sample depth on another data set,'
		@ 11,5 SAY '                                                Type Y/N >>>>' GET YN
		READ
		YN=UPPE(YN)
		IF 'Y' $ YN
			CHKNEW=1
			EXIT
		ELSE
			IF 'N' $ YN
				CHKNEW=2
				EXIT
			ENDI
			@ 10,23 SAY 'Incorrect Selection - Try Again'
			LOOP
		ENDI
	ENDD
	IF CHKNEW=1
		CLEA
		LOOP
	ELSE
		EXIT
	ENDI
ENDD

CLEA
SET SCOR ON
SET TALK ON
SET ECHO ON
SET STAT ON
